aboutsummaryrefslogtreecommitdiff
path: root/config/zsh
diff options
context:
space:
mode:
Diffstat (limited to 'config/zsh')
-rw-r--r--config/zsh/.zshrc3
-rw-r--r--config/zsh/appearance.zsh73
-rw-r--r--config/zsh/behavior.zsh65
-rw-r--r--config/zsh/completion.zsh52
-rw-r--r--config/zsh/function-overrides.zsh8
-rw-r--r--config/zsh/key-bindings.zsh6
-rw-r--r--config/zsh/zshrc17
-rw-r--r--config/zsh/zshrc-local23
8 files changed, 247 insertions, 0 deletions
diff --git a/config/zsh/.zshrc b/config/zsh/.zshrc
new file mode 100644
index 0000000..ee3ebdd
--- /dev/null
+++ b/config/zsh/.zshrc
@@ -0,0 +1,3 @@
+# just a shim to make the real zshrc not hidden
+# since zsh doesn't support renaming the config
+source "$ZDOTDIR/zshrc"
diff --git a/config/zsh/appearance.zsh b/config/zsh/appearance.zsh
new file mode 100644
index 0000000..e7132a8
--- /dev/null
+++ b/config/zsh/appearance.zsh
@@ -0,0 +1,73 @@
+#
+# colorize shell programs
+
+if ls --color -d . &>/dev/null 2>&1; then
+ alias ls='ls --color=tty'
+ eval `dircolors ${XDG_CONFIG_HOME:-${HOME}/.config}/dircolors.conf`
+else
+ alias ls='ls -G'
+ export LSCOLORS="exgxbxdxcxegedxbxgxcxd"
+fi
+
+# grep
+export GREP_COLOR='1;32'
+alias grep='grep --color=auto'
+alias egrep='egrep --color=auto'
+alias fgrep='fgrep --color=auto'
+
+# less
+export LESS_TERMCAP_mb=$'\e[0;31m' # begin blinking - red
+export LESS_TERMCAP_md=$'\e[0;34m' # begin bold - blue
+export LESS_TERMCAP_me=$'\e[0m' # end mode
+export LESS_TERMCAP_so=$'\e[30;46m' # begin standout mode - black on cyan
+export LESS_TERMCAP_se=$'\e[0m' # end standout mode
+export LESS_TERMCAP_us=$'\e[4;33m' # begin underline - yellow underline
+export LESS_TERMCAP_ue=$'\e[0m' # end underline
+
+#
+# make a sweet prompt
+
+autoload colors; colors;
+setopt prompt_subst # expansion of color codes, etc. in the prompt
+
+# print the fully resolved shell command with time stamp
+# to be run from zsh's builtin 'preexec' with all arguments passed through ($*)
+function theme_preexec () {
+ echo "($fg[magenta]`date +%r`$reset_color) $fg[cyan]$3$reset_color"
+}
+
+# print the prompt char in red if the last command exited non-zero
+function prompt_char {
+ echo "%(?.$.%{$fg[red]%}$%{$reset_color%})"
+}
+
+function repo_prompt_info {
+ # git
+ ref=$(git symbolic-ref HEAD 2> /dev/null || git rev-parse --short HEAD 2> /dev/null)
+ if [ $? -eq 0 ]; then
+ #repo=$(basename $(git rev-parse --show-toplevel))
+ echo "%{$fg[cyan]%}%{\e[1m%}${ref#refs/heads/}%{$reset_color%}"
+ return
+ fi
+}
+
+function workspace_prompt_info {
+ repo=$(repo_prompt_info)
+ if [ "$repo" ]; then
+ echo "[$repo] "
+ return
+ fi
+}
+
+# print the hostname in green if local, else red
+function hostname_info {
+ if [[ $ZSH_LOCAL_ENV == "true" ]]; then
+ echo "%{$fg[green]%}%{$ZSH_HOST_PREFIX%}%m%{$ZSH_HOST_SUFFIX%}%{$reset_color%}"
+ else
+ echo "%{$fg[red]%}%{$ZSH_HOST_PREFIX%}%m%{$ZSH_HOST_SUFFIX%}%{$reset_color%}"
+ fi
+}
+
+# a colorful multiline prompt using the above defined functions
+PROMPT=$'%{$fg[yellow]%}%n%{$reset_color%}@$(hostname_info):%{$fg[blue]%}%~%{$reset_color%}
+$(workspace_prompt_info)$(prompt_char)%{$reset_color%} '
diff --git a/config/zsh/behavior.zsh b/config/zsh/behavior.zsh
new file mode 100644
index 0000000..e7e6b81
--- /dev/null
+++ b/config/zsh/behavior.zsh
@@ -0,0 +1,65 @@
+#
+# execution
+
+setopt rm_star_wait # wait 10 seconds before accepting 'rm *' confirmation
+export REPORTTIME=5 # report timing for any command longer than 5 seconds
+unsetopt flowcontrol # disable ^s from freezing the terminal
+
+#
+# history
+
+HISTFILE="${XDG_DATA_HOME:-${HOME}/.local/share}/zsh/history"
+HISTSIZE=10000
+SAVEHIST=10000
+
+setopt hist_ignore_all_dups # ignore dups including non-sequential ones
+setopt share_history # share command history data between sessions
+setopt hist_verify # load hist into command buffer rather than exec immediately
+
+#
+# term support
+
+# set term title appropriately based on term type
+# user@host:current_dir (current_command)
+case "$TERM" in
+ xterm*|rxvt*|screen*|alacritty*)
+ term_preexec () {
+ printf '\e]0;%s (%s)\a' ${(%):-'%n@%m:%~'} "$1"
+ }
+ term_precmd () {
+ printf '\e]0;%s\a' ${(%):-'%n@%m:%~'}
+ }
+ ;;
+esac
+
+#
+# virtualenv
+
+if [ -e /usr/local/bin/virtualenvwrapper_lazy.sh ]; then
+ vew=/usr/local/bin/virtualenvwrapper_lazy.sh
+elif [ -e /usr/share/virtualenvwrapper/virtualenvwrapper_lazy.sh ]; then
+ vew=/usr/share/virtualenvwrapper/virtualenvwrapper_lazy.sh
+fi
+
+if [ -n "$vew" ]; then
+ export VIRTUAL_ENV_DISABLE_PROMPT=true
+ export WORKON_HOME=~/.virtualenv/envs
+ source $vew
+fi
+
+#
+# draw a horizontal separator
+
+function hr {
+ printf "$bg[red]${(l:$COLUMNS:: :)}$reset_color\n"
+ printf "$bg[yellow]${(l:$COLUMNS:: :)}\n"
+ printf "$bg[green]${(l:$COLUMNS:: :)}\n"
+ printf "$bg[cyan]${(l:$COLUMNS:: :)}\n"
+ printf "$bg[blue]${(l:$COLUMNS:: :)}\n"
+ printf "$bg[magenta]${(l:$COLUMNS:: :)}$reset_color\n"
+}
+
+#
+# less
+
+export LESS=-i
diff --git a/config/zsh/completion.zsh b/config/zsh/completion.zsh
new file mode 100644
index 0000000..740e9a3
--- /dev/null
+++ b/config/zsh/completion.zsh
@@ -0,0 +1,52 @@
+# initialize the completion system
+autoload -U compinit
+zmodload zsh/complist
+compinit -d "${XDG_CACHE_HOME:-${HOME}/.cache}/zsh/zcompdump-${ZSH_VERSION}"
+
+# complete only after the second consecutive tab
+setopt auto_menu
+
+# use GNU ls color specification for completion menu
+zstyle ':completion:*:default' list-colors ${(s.:.)LS_COLORS}
+
+# use menu selection by default
+zstyle ':completion:*:default' menu select
+
+# custom completion list for processes (just current user's)
+zstyle ':completion:*:*:*:*:processes' command "ps -u `whoami` -o pid,user,comm -w -w"
+# special colors for kill completion listing
+zstyle ':completion:*:*:kill:*:processes' list-colors '=(#b) #([0-9]#) ([0-9a-z-]#)*=01;34=0=01'
+
+# disable named-directories autocompletion
+zstyle ':completion:*:cd:*' tag-order local-directories directory-stack path-directories
+cdpath=(.)
+
+# use /etc/hosts and known_hosts for hostname completion
+[ -r ~/.ssh/known_hosts ] && _ssh_hosts=(${${${${(f)"$(<$HOME/.ssh/known_hosts)"}:#[\|]*}%%\ *}%%,*}) || _ssh_hosts=()
+[ -r /etc/hosts ] && : ${(A)_etc_hosts:=${(s: :)${(ps:\t:)${${(f)~~"$(</etc/hosts)"}%%\#*}##[:blank:]#[^[:blank:]]#}}} || _etc_hosts=()
+hosts=(
+ "$_ssh_hosts[@]"
+ "$_etc_hosts[@]"
+ `hostname`
+ localhost
+)
+zstyle ':completion:*:hosts' hosts $hosts
+
+# Use caching so that commands like apt and dpkg complete are useable
+zstyle ':completion::complete:*' use-cache 1
+
+# Don't complete uninteresting users
+zstyle ':completion:*:*:*:users' ignored-patterns \
+ adm amanda apache avahi beaglidx bin cacti canna clamav daemon \
+ dbus distcache dovecot fax ftp games gdm gkrellmd gopher \
+ hacluster haldaemon halt hsqldb ident junkbust ldap lp mail \
+ mailman mailnull mldonkey mysql nagios \
+ named netdump news nfsnobody nobody nscd ntp nut nx openvpn \
+ operator pcap postfix postgres privoxy pulse pvm quagga radvd \
+ rpc rpcuser rpm shutdown squid sshd sync uucp vcsa xfs
+
+# ... unless we really want to.
+zstyle ':completion:*' single-ignored show
+
+# always rehash commands list
+zstyle ':completion:*:commands' rehash 1
diff --git a/config/zsh/function-overrides.zsh b/config/zsh/function-overrides.zsh
new file mode 100644
index 0000000..8b233e5
--- /dev/null
+++ b/config/zsh/function-overrides.zsh
@@ -0,0 +1,8 @@
+preexec () {
+ type term_preexec &> /dev/null && term_preexec $*
+ type theme_preexec &> /dev/null && theme_preexec $*
+}
+
+precmd () {
+ type term_precmd &> /dev/null && term_precmd
+}
diff --git a/config/zsh/key-bindings.zsh b/config/zsh/key-bindings.zsh
new file mode 100644
index 0000000..4deac62
--- /dev/null
+++ b/config/zsh/key-bindings.zsh
@@ -0,0 +1,6 @@
+bindkey -e # use emacs mode
+bindkey '^r' history-incremental-search-backward # ctrl-r
+bindkey '^[[Z' reverse-menu-complete # shift-tab
+
+bindkey '\e[3~' delete-char # make sure delete key works
+bindkey ' ' magic-space # also do history expansion on space
diff --git a/config/zsh/zshrc b/config/zsh/zshrc
new file mode 100644
index 0000000..2a0fcf0
--- /dev/null
+++ b/config/zsh/zshrc
@@ -0,0 +1,17 @@
+export EDITOR=vim
+export LANG=en_US.UTF-8
+
+if [ -e "$ZDOTDIR/zshrc-local" ]; then
+ source "$ZDOTDIR/zshrc-local"
+fi
+
+source "$ZDOTDIR/appearance.zsh"
+source "$ZDOTDIR/behavior.zsh"
+source "$ZDOTDIR/completion.zsh"
+source "$ZDOTDIR/key-bindings.zsh"
+
+# override builtin functions (preexec, precmd, etc.)
+source "$ZDOTDIR/function-overrides.zsh"
+
+# user bin should take absolute priority
+export PATH="$HOME/bin:$PATH"
diff --git a/config/zsh/zshrc-local b/config/zsh/zshrc-local
new file mode 100644
index 0000000..50a16b2
--- /dev/null
+++ b/config/zsh/zshrc-local
@@ -0,0 +1,23 @@
+# get sbin on the path
+#export PATH="/usr/sbin:/sbin:$PATH"
+
+# move homebrew stuff to the beginning of the search path
+#export PATH="/usr/local/bin:/usr/local/sbin:$PATH"
+#export MANPATH="/usr/local/man:$MANPATH"
+#export PATH="/usr/local/opt/python/libexec/bin:$PATH"
+#export PATH="/usr/local/opt/coreutils/libexec/gnubin:$PATH"
+#export MANPATH="/usr/local/opt/coreutils/libexec/gnuman:$MANPATH"
+#export PATH="/usr/local/opt/findutils/libexec/gnubin:$PATH"
+#export MANPATH="/usr/local/opt/findutils/libexec/gnuman:$MANPATH"
+#export PATH="/usr/local/opt/grep/libexec/gnubin:$PATH"
+#export MANPATH="/usr/local/opt/grep/libexec/gnuman:$MANPATH"
+
+# Java
+#export JAVA_HOME="$(/usr/libexec/java_home -v 1.8)"
+
+# start the ssh agent on login and stop on logout
+#eval `ssh-agent -s`
+#trap 'eval `ssh-agent -k`' 0
+
+# prompt hostname is highlighted in red for non-local envs
+export ZSH_LOCAL_ENV=true